# Overview

A simple example project to use SAM/CodeDeploy preTrafficHooks
to validate a lambda before finishing the deployment

## Install, Linting, Testing, Deploying, Integration-Testing

* Code uses black for formatting and pylint for code-standards
* Tests use pytest
* Deployment uses cloudformation via [SAM] for simplification
* Integration Tests are part of the cloudformation

See `make help` for more details

### Deployment

Environment overrides can be written in `environments/<env>.env`
then launched with `make all env=<env>`

#### CI

This folder has scripts to

* Deploy and Delete a CI environment
* Deploy a permanent environment based on `environments/<env>.env`
* Cleanup environments after merging

## Contributing

Before contributing, please run all tests in a clean environment,
e.g run `make all`

[SAM]: https://github.com/awsdocs/aws-sam-developer-guide/blob/master/doc_source/sam-specification.md
